-- Draw the virtual keyboard
-- Draw the virtual keyboard
function touchKeyboard:draw()
function touchKeyboard:draw()
    -- Draw the background rectangle
    love.graphics.setColor(0.3, 0.3, 0.3)
    love.graphics.rectangle("fill", 0, 0, 2405, 760)

    local layout = selectKeyboardLayout() -- Select the appropriate keyboard layout

    -- Draw the keys first
    for i, row in ipairs(layout) do
        local rowOffset = (i - 1) * 0.5 * (keyWidth + keyPadding) -- Offset for row displacement
        for j, key in ipairs(row) do
            local keyX = rowOffset + (j - 1) * (keyWidth + keyPadding)
            local keyY = (i - 1) * (keyHeight + keyPadding)
            local keyOffsetX = 0
            local keyWidthMultiplier = 1

             -- Adjust offsets and multipliers based on key type
				if key == "strg" then
					keyOffsetX = -keyWidth * 2
					keyWidthMultiplier = 2.0
			elseif key == "linux" or key == "alt" then
					keyOffsetX = -keyWidth * 1
					keyWidthMultiplier = 1.0
            elseif key == "alt gr" or key == "fn" or key == "fn2" then
                keyOffsetX = keyWidth * 5
                keyWidthMultiplier = 1.0
            elseif key == "strg2" then
                keyOffsetX = keyWidth * 5
                keyWidthMultiplier = 1.5
            elseif key == "Space" then
                keyOffsetX = -keyWidth * 1
                keyWidthMultiplier = 7
            elseif key == "Upper" or key == "Upper2" then
                keyOffsetX = -keyWidth * 1.5
                keyWidthMultiplier = 2.49
            elseif key == "Upper3" then
                keyWidthMultiplier = 1.9
            elseif key == "Tab" then
                keyOffsetX = -keyWidth * 0.5
                keyWidthMultiplier = 1.5
            elseif key == "ret" then
				keyWidthMultiplier = 2
            elseif key == "ret2" then
				keyWidthMultiplier = 1.7
            elseif key == "del" then
				keyWidthMultiplier = 2.4
            end
            

            -- Calculate the current key width
            local currentKeyWidth = keyWidth * keyWidthMultiplier + keyPadding * (keyWidthMultiplier - 1)

            -- Set color and transparency based on key selection
            local isSelected = self.selectedKey == key
            if isSelected then
                self.keyTransparency[key] = self.keyTransparency[key] or 1
                love.graphics.setColor(0.2, 0.2, 0.8, self.keyTransparency[key])
            elseif self.keyTransparency[key] and self.keyTransparency[key] >= 0.1 then
                love.graphics.setColor(0.2, 0.2, 0.8, self.keyTransparency[key])
            else
                love.graphics.setColor(0, 0, 0, 1)
            end

            -- Draw the key
            love.graphics.rectangle("fill", keyX + keyOffsetX, keyY, currentKeyWidth, keyHeight)

            -- Draw the key label
            love.graphics.setColor(1, 1, 1)
            love.graphics.print(key, keyX + keyOffsetX + currentKeyWidth / 2 - 15, keyY + keyHeight / 2 - 10,0,2)
        end
    end
end

end

